/**
**************************************************************************
* @file interface_config.h
* @brief Конфигурации для интерфейсов
**************************************************************************
  * @defgroup    INTERFACE_CONFIGS     Configs for interfaces
  * @brief       Конфигурации для интерфейсов
  * @details     
	@{
*************************************************************************/
#ifndef _INTERFACE_CONFIG_H_
#define _INTERFACE_CONFIG_H_

/** 
	* @addtogroup 		MODBUS_CONFIG   Конфигурации для модбас
	* @ingroup        INTERFACE_CONFIGS
	* @ingroup        MODBUS
	@{
	*/

#define MODBUS_UART_NUMB 							3							///< Номер используемого UART, по нему выставляется дефайн USED_MB_UART = USARTx
#define MODBUS_SPEED									115200			  ///< Скорость UART для модбас
#define MODBUS_GPIOX									GPIOB					///< Порт для UART RX/TX
#define MODBUS_GPIO_PIN_RX						GPIO_PIN_11		///< Пин для UART RX
#define MODBUS_GPIO_PIN_TX						GPIO_PIN_10		///< Пин для UART TX

#define MODBUS_TIM_NUMB 							7							///< number of used tim, accord to this define sets define USED_MB_TIM = TIMx 
#define MODBUS_TIM_AHB_FREQ						72						///< TIM AHB Bus Freq

// defines for modbus behaviour 
#define MODBUS_DEVICE_ID 							1			///< девайс текущего устройства
#define MODBUS_MAX_TIMEOUT 						5000 	///< максимальнйы тайтаут MB is ms


#define RS_UART_Init                  MX_USART1_UART_Init
#define RS_UART_DeInit                HAL_UART_MspDeInit
#define RS_TIM_Init                   MX_TIM2_Init
#define RS_TIM_DeInit                 HAL_TIM_Base_MspDeInit
#define rs_huart                      huart1
#define rs_htim                       htim2



/////////////////////////////////////////////////////////////////////
/////////////////////////---CALC DEFINES---//////////////////////////

/* set USART_TypeDef for choosen numb of usart */
#if (MODBUS_UART_NUMB == 1) 
	#define USED_MODBUS_UART					USART1 
	#define USE_USART1
#elif (MODBUS_UART_NUMB == 2)
	#define USED_MODBUS_UART					USART2 
	#define USE_USART2
#elif (MODBUS_UART_NUMB == 3)
	#define USED_MODBUS_UART					USART3 
	#define USE_USART3
#elif (MODBUS_UART_NUMB == 4)
	#define USED_MODBUS_UART					UART4 
	#define USE_UART4
#elif (MODBUS_UART_NUMB == 5)
	#define USED_MODBUS_UART					UART5
	#define USE_UART6
#elif (MODBUS_UART_NUMB == 6)
	#define USED_MODBUS_UART					USART6 
	#define USE_USART6
#endif

#if (MODBUS_TIM_NUMB == 1) 
	#define USED_MODBUS_TIM					TIM1 
	#define USE_TIM1
#elif (MODBUS_TIM_NUMB == 2)
	#define USED_MODBUS_TIM					TIM2 
	#define USE_TIM2
#elif (MODBUS_TIM_NUMB == 3)
	#define USED_MODBUS_TIM					TIM3 
	#define USE_TIM3
#elif (MODBUS_TIM_NUMB == 4)
	#define USED_MODBUS_TIM					TIM4 
	#define USE_TIM4
#elif (MODBUS_TIM_NUMB == 5)
	#define USED_MODBUS_TIM					TIM5
	#define USE_TIM5
#elif (MODBUS_TIM_NUMB == 6)
	#define USED_MODBUS_TIM					TIM6 
	#define USE_TIM6
#elif (MODBUS_TIM_NUMB == 7)
	#define USED_MODBUS_TIM					TIM7 
	#define USE_TIM7
#elif (MODBUS_TIM_NUMB == 8)
	#define USED_MODBUS_TIM					TIM8
	#define USE_TIM8 
#elif (MODBUS_TIM_NUMB == 9)
	#define USED_MODBUS_TIM					TIM9 
	#define USE_TIM9
#elif (MODBUS_TIM_NUMB == 10)
	#define USED_MODBUS_TIM					TIM10 
	#define USE_TIM10
#elif (MODBUS_TIM_NUMB == 11)
	#define USED_MODBUS_TIM					TIM11
	#define USE_TIM11
#elif (MODBUS_TIM_NUMB == 12)
	#define USED_MODBUS_TIM					TIM12 
	#define USE_TIM12
#elif (MODBUS_TIM_NUMB == 13)
	#define USED_MODBUS_TIM					TIM13 
	#define USE_TIM13
#elif (MODBUS_TIM_NUMB == 14)
	#define USED_MODBUS_TIM					TIM14 
	#define USE_TIM14
#endif



/** MODBUS_CONFIG
  * @}
  */


  
  
/** INTERFACE_CONFIGS
  * @}
  */

#endif //_INTERFACE_CONFIG_H_