#include "tester_main.h"


TESTER_ProjectTypeDef TESTER;


/**s
  * @brief    Инициализация всех модулей для работы тестера
  */
void TESTER_Init(TESTER_ProjectTypeDef *tester)
{
  tester->delay = 250;
  tester->delay_en = 0;
  
  tester->func.disable_reset_call = 0;
  tester->htest = &hTestDiode;
  TESTER_HandleInit(tester->htest);
}


/**s
  * @brief    Функция подготовки тестера к while(1)
  */
void TESTER_pre_while(TESTER_ProjectTypeDef *tester)
{
}



/**
  * @brief    Главная функция работы тестера
  */
void TESTER_main_while(TESTER_ProjectTypeDef *tester)
{
  if(tester->delay_en)
    msDelay(tester->delay);
  
  /* ТЕСТ В ОБРАТНОМ ВКЛЮЧЕНИИ */
  if(tester->func.test_diode_neg)
  {
    if(tester->func.disable_reset_call == 0)
      tester->func.test_diode_neg = 0;
    
    TESTER_TestDiode_NegativePower(tester->htest);
  }
    
  /* ТЕСТ В ПРЯМОМ ВКЛЮЧЕНИИ */
  if(tester->func.test_diode_pos)
  {
    if(tester->func.disable_reset_call == 0)
      tester->func.test_diode_pos = 0;
    
    TESTER_TestDiode_PositivePower(tester->htest);
  }
  /* ТЕСТ ПЕРЕХОДА ИЗ ПРЯМОГО В ОБРАТНОЕ ВКЛЮЧЕНИЯ*/
  if(tester->func.test_diode_posneg)
  {
    if(tester->func.disable_reset_call == 0)
      tester->func.test_diode_posneg = 0;
    
    TESTER_TestDiode_PosNegPower(tester->htest);
  }
}

/**
  * @brief    Задеркжка главного цикла
  */
void TESTER_main_delay(TESTER_ProjectTypeDef *tester)
{
  if(tester->delay_en)
    msDelay(tester->delay);
}