/**
**************************************************************************
* @file tester_func.h
* @brief Заголовочный файл для функций МЗКТ.
**************************************************************************
@details

*************************************************************************/

	
#ifndef _TESTER_MAIN_H_
#define _TESTER_MAIN_H_

#include "tester_func.h"


/**
  * @brief Структура для вызова различных функций
	*/
typedef struct
{
  unsigned test_diode_neg:1;
  unsigned test_diode_posneg:1;
  unsigned test_diode_pos:1;
  
  unsigned disable_reset_call:1;
}function_calls;

/**
  * @brief Структура проекта тестер
	*/
typedef struct
{
  function_calls func;  ///< вызов разных функций
  
  TESTER_TestHandleTypeDef *htest;  ///< дескриптор тестера
  
  uint32_t        delay;        ///< задержка главного цикла
  uint32_t        delay_en:1;   ///< включить задержку в главном цикле
}TESTER_ProjectTypeDef;
extern TESTER_ProjectTypeDef TESTER;



/* Протестировать диод */
void TESTER_Init(TESTER_ProjectTypeDef *tester);
/* Подключить питание с помощью ключей (пинов) в TESTER_PowerSwitchTypeDef */
void TESTER_pre_while(TESTER_ProjectTypeDef *tester);
/* Отключить питание с помощью ключей (пинов) в TESTER_PowerSwitchTypeDef */
void TESTER_main_while(TESTER_ProjectTypeDef *tester);
/*Задеркжка главного цикла */
void TESTER_main_delay(TESTER_ProjectTypeDef *tester);
#endif //_TESTER_MAIN_H_

